#include "IEL.h"
#include "helloi.h"
#include "mpi.h"
#include "hellome.h"
#include "hellomy.h"


int main(int argc, char** argv) {

  MPI_Init(&argc, &argv);

  IELAddModule(helloi, "helloi");
  IELAddModule(hellome, "hellome");
  IELAddModule(hellomyself, "hellomy");

  MPI_Barrier(MPI_COMM_WORLD);
  IELExecutive(MPI_COMM_WORLD, argv[1]);
  MPI_Barrier(MPI_COMM_WORLD);
  
  MPI_Finalize();

}
