#ifndef _QUEUE_H_
#define _QUEUE_H_

typedef struct queue {
  struct queue *flink;
  struct queue *blink;
  void* val;
  int size;
} *Queue;

Queue new_queue();
void free_queue(Queue);

void q_push(Queue, void*, int);
void* q_pop(Queue, int*);
void* q_peek(Queue, int*);

int q_isEmpty(Queue);

#define q_first(d) ((d)->flink)
#define q_next(d) ((d)->flink)
#define q_last(d) ((d)->blink)
#define q_prev(d) ((d)->blink)
#define q_nil(d) (d)

#endif
