#!/bin/bash

# USAGE: ./ship_diel.sh <absolute path to openDIEL-V2>
# EXAMPLE: ./ship_diel.sh /home/jpollac1/dev/openDIEL-V2

# This script is designed to prepare a copy of openDIEL that
# is ready to be published on the website.

DIEL_PATH=$1

#Remove 
rm -rf $DIEL_PATH/APPLICATION/DEALII
rm -rf $DIEL_PATH/APPLICATION/DG
rm -rf $DIEL_PATH/APPLICATION/ENERGYPLUS
rm -rf $DIEL_PATH/APPLICATION/FEM
rm -rf $DIEL_PATH/APPLICATION/FLUID
rm -rf $DIEL_PATH/APPLICATION/GENETIC_SPHERE
rm -rf $DIEL_PATH/APPLICATION/HEAT
#rm -rf $DIEL_PATH/APPLICATION/HELLOWORLD
rm -rf $DIEL_PATH/APPLICATION/LAMMPS
rm -rf $DIEL_PATH/APPLICATION/MAVEN
rm -rf $DIEL_PATH/APPLICATION/PICMSS
rm -rf $DIEL_PATH/APPLICATION/PSUADE
rm -rf $DIEL_PATH/APPLICATION/REDIFF
rm -rf $DIEL_PATH/APPLICATION/THERMAL
rm -rf $DIEL_PATH/APPLICATION/VIJAY

rm -rf $DIEL_PATH/SRC

find $DIEL_PATH -name .svn -exec rm -rf {} \;
